## cba4b6de7241d339de4aa08cdcf55c2bd2293a66

=== Makefile ===
# Copyright (c) 2021, Dell Inc. or its subsidiaries.  All rights reserved.
# SPDX-License-Identifier: Apache-2.0
# See the LICENSE file for details.
#
# This file is part of NVMe STorage Appliance Services (nvme-stas).
#
# Authors: Martin Belanger <Martin.Belanger@dell.com>
#
.DEFAULT_GOAL     := stas
BUILD-DIR         := .build
DEB-PKG-DIR       := ${BUILD-DIR}/deb-pkg
RPM-BUILDROOT-DIR := ${BUILD-DIR}/rpmbuild

.PHONY: update-subprojects
update-subprojects:
	meson subprojects update

${BUILD-DIR}:
	BUILD_DIR=${BUILD-DIR} ./configure
	@echo "Configuration located in: $@"
	@echo "-------------------------------------------------------"

.PHONY: stas
stas: ${BUILD-DIR}
	ninja -C ${BUILD-DIR}

.PHONY: clean
clean:
ifneq ("$(wildcard ${BUILD-DIR})","")
	ninja -C ${BUILD-DIR} -t clean
endif

.PHONY: purge
purge:
ifneq ("$(wildcard ${BUILD-DIR})","")
	rm -rf ${BUILD-DIR}
endif

.PHONY: install
install: stas
	sudo meson $@ -C ${BUILD-DIR} --skip-subprojects

.PHONY: uninstall
uninstall: ${BUILD-DIR}
	sudo ninja -C ${BUILD-DIR} uninstall

.PHONY: dist
dist: stas
	meson $@ -C ${BUILD-DIR} --formats gztar

.PHONY: test
test: stas
	meson $@ -C ${BUILD-DIR} --suite nvme-stas

.PHONY: loc
loc:
	@cloc --by-file --exclude-dir=${BUILD-DIR},doc,subprojects,test,utils,debian,obj-x86_64-linux-gnu,.github --exclude-lang=Markdown,"NAnt script",XML,"Bourne Again Shell",make,"Bourne Shell",Meson,YAML,XSLT .

.PHONY: loc-full
loc-full:
	@cloc --by-file --exclude-dir=${BUILD-DIR},subprojects,debian,obj-x86_64-linux-gnu,.github .

# Coverage requirements:
#   pip install coverage
.PHONY: coverage
coverage: stas
	cd ${BUILD-DIR} && ./coverage.sh

################################################################################
# Debian (*.deb)
# Use "DEB_BUILD_OPTIONS=nocheck make deb" to skip unit testing.
# This requires: sudo apt install -y debhelper dh-python
ifeq (deb,$(strip $(MAKECMDGOALS)))
  ifneq (SUCCESS,$(shell dpkg -s debhelper dh-python > /dev/null 2>&1 && echo "SUCCESS" || echo "FAIL"))
    $(error Missing packages. Run -> "sudo apt install -y debhelper dh-python")
  endif
endif

.PHONY: deb
deb: ${BUILD-DIR}
	mkdir -p ${DEB-PKG-DIR}
	dpkg-buildpackage -us -uc
	@mv ../nvme-stas_*.deb ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.buildinfo ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.changes ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.dsc ${DEB-PKG-DIR}
	@mv ../nvme-stas_*.tar.gz ${DEB-PKG-DIR}
	@echo "======================================================="
	@echo "Debian packages located in: ${DEB-PKG-DIR}/"


################################################################################
# RedHat (*.rpm)
${BUILD-DIR}/nvme-stas.spec: ${BUILD-DIR} nvme-stas.spec.in
	meson --reconfigure ${BUILD-DIR}

${RPM-BUILDROOT-DIR}: ${BUILD-DIR}/nvme-stas.spec
	rpmbuild -ba $< --build-in-place --clean --nocheck --define "_topdir $(abspath ${BUILD-DIR}/rpmbuild)"
	@echo "======================================================="
	@echo "RPM packages located in: ${RPM-BUILDROOT-DIR}/"

.PHONY: rpm
rpm: ${RPM-BUILDROOT-DIR}

=== meson_options.txt ===
# -*- mode: meson -*-

option('man',         type: 'boolean', value: false, description: 'build and install man pages')
option('html',        type: 'boolean', value: false, description: 'build and install html pages')
option('readthedocs', type: 'boolean', value: false,  description: 'to be used by Read-The-Docs documentation builder')
option('rt_pymods_reqd', type: 'boolean', value: false,  description: 'Make sure all run-time python modules are installed')

=== debian/control ===
Source: nvme-stas
Section: misc
Priority: optional
Maintainer: Martin Belanger <Martin.Belanger@dell.com>
Build-Depends: debhelper-compat (= 12), python3-setuptools, dh-python
Standards-Version: 4.4.1
#Homepage: <insert the upstream URL, if relevant>
#Vcs-Browser: https://salsa.debian.org/debian/pack
#Vcs-Git: https://salsa.debian.org/debian/pack.git
#Testsuite: autopkgtest-pkg-python

Package: nvme-stas
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, python3-pyudev, python3-systemd, python3-gi python3-dasbus python3-libnvme
Description: NVMe STorage Appliance Services
 This package provides two daemons, stafd and stacd. The STorage Appliance
 Finder Daemon (stafd) automatically discovers NVMe-oF Discovery Controllers (DC)
 and retrieves the list of NVMe Storage Appliances. The STorage Appliance
 Connector Daemon (stacd) establishes I/O connections to the NVMe Storage
 Appliances discovered by stafd.
 .
 This package installs the library for Python 3.
